unit Express;
interface
uses
  Math;

  function Func(FunStr: string; VarVal: extended): extended;

implementation
uses
  Classes, SysUtils;
var
  StandartFuncts: TStringList;
  Variable: extended;

procedure DelSpace(var s: string);
begin
  if s='' then Exit;
  while (s<>'') and (s[1]=' ')          do delete(s,1,1);
  while (s<>'') and (s[length(s)]=' ')  do delete(s,length(s),1);
end;

function ExpressEvalf(Oper: char; s: string): extended;
var
  op: word;
  v: variant;

  function OperPos(Opers: array of char): boolean;
  var
    p,i, so,sc: word;
  begin
    so:=0; sc:=0;
    for p:= 1 to length(s) do
      case s[p] of
        '(': inc(so);
        ')': inc(sc);
      else if so=sc then
        for i:= 0 to high(Opers) do
          if s[p] = Opers[i] then begin
            if ((s[p] = '+') or (s[p] = '-')) and
               (UpperCase(s[p-1]) = 'E') then break;
            if p = length(s) then
              raise Exception.Create(' ');
            op:= p;
            Result:= true;
            Exit;
          end
      end;
    Result:= false;
  end;

  function Par1(Oper: char): variant;
  begin
    if op = 1
      then Result:= varEmpty
      else Result:= ExpressEvalf(Oper, Copy(s,1,op-1));
  end;

  function Par2(Oper: char): variant;
  begin
    Result:= ExpressEvalf(Oper, Copy(s,op+1,length(s)-op))
  end;

  function OperFunc(Oper: char; val: extended): extended;
  begin
    Result:= val;
    case Oper of
      '-': Result:= -Result;
      '/': Result:= 1/Result;
    end
  end;

  function Param: boolean;
  var i: word;

    function FuncProc(FuncIndex: word): extended;
      function ParamProc(s: string): extended;
      begin
        Result:= ExpressEvalf(#0, s)
      end;

    begin
      case FuncIndex of
        0: Result:= Abs(ParamProc(s));
        1: Result:= Sin(ParamProc(s));
        2: Result:= Cos(ParamProc(s));
        3: Result:= ArcTan(ParamProc(s));
        4: Result:= Exp(ParamProc(s));
        5: Result:= Ln(ParamProc(s));
      else
        raise Exception.Create(' ');
      end;
    end;

  begin
    with StandartFuncts do
    for i:= 0 to Count-1 do
      if Pos(Strings[i], UpperCase(s)) = 1 then begin
        System.Delete(s, 1, length(Strings[i]));
        DelSpace(s);
        s:= System.Copy(s, 2, length(s)-2);
        if (s[1] = '(') and (s[length(s)] = ')') then
          raise Exception.Create(' ');
        ExpressEvalf:= OperFunc(Oper, FuncProc(i));
        Result:= true;
        Exit;
      end;

    if Pos('PI', UpperCase(s)) = 1 then begin
      ExpressEvalf:= Pi;
      Result:= true;
      Exit;
    end;

    if Pos('X', UpperCase(s)) = 1 then begin
      ExpressEvalf:= Variable;
      Result:= true;
      Exit;
    end;

    Result:= false;
  end;

begin
  DelSpace(s);
  if s = '' then raise Exception.Create(' ');
  if OperPos(['+','-']) then begin
    v:= Par1(Oper); if v = varEmpty then v:= 0;
    Result:= v + Par2(s[op]);
  end

  else if OperPos(['*','/']) then
    Result:= OperFunc(Oper, Par1(#0)) * Par2(s[op])

  else if OperPos(['^']) then
    Result:= OperFunc(Oper, Power(Par1(#0), Par2(s[op])))

  else if s[1] = '(' then
    if s[length(s)] = ')' then
      Result:= OperFunc(Oper, ExpressEvalf(#0, Copy(s,2,length(s)-2)))
    else raise Exception.Create(' ')

  else if not Param then
    Result:= OperFunc(Oper, StrToFloat(s));

end;

function Func(FunStr: string; VarVal: extended): extended;
begin
  Variable:= VarVal;
  Result:= ExpressEvalf(#0, FunStr);
end;

initialization
  StandartFuncts:= TStringList.Create;
  with StandartFuncts do begin
    Add('ABS');
    Add('SIN');
    Add('COS');
    Add('ARCTAN');
    Add('EXP');
    Add('LN');
  end;
finalization
  StandartFuncts.Free;
end.
